## ignition-gui3 3.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-gui3 VERSION 3.8.0)

#============================================================================
# Find ignition-cmake
#============================================================================
find_package(ignition-cmake2 2.8.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================


#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Protobuf
set(REQ_PROTOBUF_VER 3)
ign_find_package(IgnProtobuf
                 VERSION ${REQ_PROTOBUF_VER}
                 REQUIRED
                 PRETTY Protobuf)

#--------------------------------------
# Find Tinyxml2
ign_find_package(TINYXML2 REQUIRED PRIVATE PRETTY tinyxml2)

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math6 REQUIRED)
set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})

#--------------------------------------
# Find ignition-common
ign_find_package(ignition-common3 REQUIRED)
set(IGN_COMMON_VER ${ignition-common3_VERSION_MAJOR})

#--------------------------------------
# Find ignition-plugin
ign_find_package(ignition-plugin1 REQUIRED COMPONENTS loader register)
set(IGN_PLUGIN_VER ${ignition-plugin1_VERSION_MAJOR})

#--------------------------------------
# Find ignition-transport
ign_find_package(ignition-transport8 REQUIRED)
set(IGN_TRANSPORT_VER ${ignition-transport8_VERSION_MAJOR})

#--------------------------------------
# Find ignition-rendering
ign_find_package(ignition-rendering3 REQUIRED COMPONENTS ogre VERSION 3.5.0)
set(IGN_RENDERING_VER ${ignition-rendering3_VERSION_MAJOR})

#--------------------------------------
# Find ignition-msgs
ign_find_package(ignition-msgs5 REQUIRED)
set(IGN_MSGS_VER ${ignition-msgs5_VERSION_MAJOR})

#--------------------------------------
# Find if ign command is available
find_program(HAVE_IGN_TOOLS ign)

#--------------------------------------
# Find QT
ign_find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
  PKGCONFIG "Qt5Core Qt5Quick Qt5QuickControls2"
)

set(IGNITION_GUI_PLUGIN_INSTALL_DIR
  ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${IGN_DESIGNATION}-${PROJECT_VERSION_MAJOR}/plugins
)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS)

#============================================================================
# ign command line support
#============================================================================
add_subdirectory(conf)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
  ADDITIONAL_INPUT_DIRS "${CMAKE_SOURCE_DIR}/src/plugins"
  IMAGE_PATH_DIRS "${CMAKE_SOURCE_DIR}/tutorials/images"
  TAGFILES
    "${CMAKE_SOURCE_DIR}/doc/qt.tag.xml=http://doc.qt.io/qt-5/"
    "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
    "${IGNITION-MSGS_DOXYGEN_TAGFILE} = ${IGNITION-MSGS_API_URL}"
    "${IGNITION-TRANSPORT_DOXYGEN_TAGFILE} = ${IGNITION-TRANSPORT_API_URL}"
    "${IGNITION-COMMON_DOXYGEN_TAGFILE} = ${IGNITION-COMMON_API_URL}"
)

file(COPY ${CMAKE_SOURCE_DIR}/tutorials/images/ DESTINATION ${CMAKE_BINARY_DIR}/doxygen/html/images/)

=== src/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR})

set (sources
  ${CMAKE_CURRENT_SOURCE_DIR}/Application.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/Conversions.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/Dialog.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/DragDropModel.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/Helpers.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/ign.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/MainWindow.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/Plugin.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/SearchModel.cc
  PARENT_SCOPE
)

set (gtest_sources
  Application_TEST
  Conversions_TEST
  DragDropModel_TEST
  Helpers_TEST
  GuiEvents_TEST
  ign_TEST
  MainWindow_TEST
  Plugin_TEST
  SearchModel_TEST
)

if (MSVC)
  # Warning #4251 is the "dll-interface" warning that tells you when types used
  # by a class are not being exported. These generated source files have private
  # members that don't get exported, so they trigger this warning. However, the
  # warning is not important since those members do not need to be interfaced
  # with.
  set_source_files_properties(${sources} ${gtest_sources} COMPILE_FLAGS "/wd4251 /wd4146")
endif()

# this test currently fails on brew (issue #27)
# so disable it for now
if (NOT HAVE_IGN_TOOLS OR APPLE)
  list(REMOVE_ITEM gtest_sources ign_TEST.cc)
endif()

ign_build_tests(TYPE UNIT
                SOURCES
                  ${gtest_sources}
                LIB_DEPS
                  ${IGNITION-MATH_LIBRARIES}
                  TINYXML2::TINYXML2
)

add_subdirectory(cmd)
add_subdirectory(plugins)

=== src/plugins/CMakeLists.txt ===
#################################################
# ign_gui_add_library (<library_name>
#              SOURCES <sources>
#              [PUBLIC_LINK_LIBS <libraries...>]
#              [PRIVATE_LINK_LIBS <libraries...>])
#
# Add a plugin library to Ignition GUI.
#
# <library_name> Required. Name of the library
#
# [SOURCES]: Specify the source files for the plugin.
#
# [QT_HEADERS]: Qt headers that need to be MOC'ed
#
# [PUBLIC_LINK_LIBS]: Specify a list of libraries to be publicly linked.
#
# [PRIVATE_LINK_LIBS]: Specify a list of libraries to be privately linked.
#
function(ign_gui_add_library library_name)
  set(options)
  set(oneValueArgs)
  set(multiValueArgs SOURCES QT_HEADERS PUBLIC_LINK_LIBS PRIVATE_LINK_LIBS)

  cmake_parse_arguments(ign_gui_add_library "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  QT5_WRAP_CPP(${library_name}_headers_MOC ${ign_gui_add_library_QT_HEADERS})
  QT5_ADD_RESOURCES(${library_name}_RCC ${library_name}.qrc)

  add_library(${library_name} SHARED
    ${ign_gui_add_library_SOURCES}
    ${${library_name}_headers_MOC}
    ${${library_name}_RCC}
  )
  target_link_libraries(${library_name}
    PUBLIC
      ${PROJECT_LIBRARY_TARGET_NAME}
      TINYXML2::TINYXML2
      ${ign_gui_add_library_PUBLIC_LINK_LIBS}
    PRIVATE
      ${ign_gui_add_library_PRIVATE_LINK_LIBS}
  )
endfunction()

#################################################
# ign_gui_add_plugin(<plugin_name>
#              SOURCES <sources>
#              [PUBLIC_LINK_LIBS <libraries...>]
#              [PRIVATE_LINK_LIBS <libraries...>])
#
# Add a plugin to Ignition GUI.
#
# <plugin_name> Required. Name of the plugin.
#
# [SOURCES]: Specify the source files for the system.
#
# [QT_HEADERS]: Qt headers that need to be MOC'ed
#
# [TEST_SOURCES]: Source files for unit tests.
#
# [PUBLIC_LINK_LIBS]: Specify a list of libraries to be publicly linked.
#
# [PRIVATE_LINK_LIBS]: Specify a list of libraries to be privately linked.
#
function(ign_gui_add_plugin plugin_name)
  set(options)
  set(oneValueArgs)
  set(multiValueArgs
    SOURCES
    QT_HEADERS
    TEST_SOURCES
    PUBLIC_LINK_LIBS
    PRIVATE_LINK_LIBS
  )

  cmake_parse_arguments(ign_gui_add_plugin "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  ign_gui_add_library(${plugin_name}
    SOURCES ${ign_gui_add_plugin_SOURCES}
    QT_HEADERS ${ign_gui_add_plugin_QT_HEADERS}
    PUBLIC_LINK_LIBS ${ign_gui_add_plugin_PUBLIC_LINK_LIBS}
    PRIVATE_LINK_LIBS ${ign_gui_add_plugin_PRIVATE_LINK_LIBS} ignition-plugin${IGN_PLUGIN_VER}::register
  )

  if(ign_gui_add_plugin_TEST_SOURCES)
    ign_build_tests(TYPE UNIT
      SOURCES
        ${ign_gui_add_plugin_TEST_SOURCES}
      LIB_DEPS
        ${IGNITION-GUI_LIBRARIES}
        TINYXML2::TINYXML2
        ${plugin_name}
      INCLUDE_DIRS
        # Used to make internal source file headers visible to the unit tests
        ${CMAKE_CURRENT_SOURCE_DIR}
        # Used to make test-directory headers visible to the unit tests
        ${PROJECT_SOURCE_DIR}
        # Used to make test_config.h visible to the unit tests
        ${PROJECT_BINARY_DIR})
  endif()

  if (MSVC)
    # Warning #4251 is the "dll-interface" warning that tells you when types used
    # by a class are not being exported. These generated source files have private
    # members that don't get exported, so they trigger this warning. However, the
    # warning is not important since those members do not need to be interfaced
    # with.
    set_source_files_properties(
        ${ign_gui_add_plugin_SOURCES}
        ${ign_gui_add_plugin_TEST_SOURCES}
        COMPILE_FLAGS "/wd4251")
  endif()

  install (TARGETS ${plugin_name} DESTINATION ${IGNITION_GUI_PLUGIN_INSTALL_DIR})
endfunction()

# Plugins
add_subdirectory(grid_3d)
add_subdirectory(image_display)
add_subdirectory(key_publisher)
add_subdirectory(publisher)
add_subdirectory(scene3d)
add_subdirectory(screenshot)
add_subdirectory(teleop)
add_subdirectory(topic_echo)
add_subdirectory(topic_viewer)
add_subdirectory(world_control)
add_subdirectory(world_stats)

=== test/plugins/CMakeLists.txt ===
if (WIN32)
  add_definitions(-DBUILDING_DLL)
endif()

include_directories(
  ${PROJECT_SOURCE_DIR}
)

link_directories(
)

set (plugins
  TestBadInheritancePlugin
  TestNotRegisteredPlugin
  TestPlugin
)

# Plugin shared libraries
foreach (src ${plugins})
  QT5_WRAP_CPP(${src}_MOC ${src}.hh)
  if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${src}.qrc")
    QT5_ADD_RESOURCES(${src}_RCC ${src}.qrc)
  endif()
  add_library(${src} SHARED
    ${src}.cc
    ${${src}_MOC}
    ${${src}_RCC}
  )
  target_link_libraries(${src}
    PUBLIC
    ${PROJECT_LIBRARY_TARGET_NAME}
    PRIVATE
    ignition-plugin${IGN_PLUGIN_VER}::register
  )
endforeach (src ${qt_headers_local})

=== examples/plugin/custom_context_menu/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)
find_package(ignition-common3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

QT5_ADD_RESOURCES(resources_RCC CustomContext.qrc)

include_directories(SYSTEM
  ${IGNITION-COMMON_INCLUDE_DIRS}
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-COMMON_LIBRARY_DIRS}
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate examples
add_library(CustomContext SHARED ${headers_MOC}
  CustomContext.cc
  ${resources_RCC}
)
target_link_libraries(CustomContext
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/plugin/dialog_from_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)
find_package(ignition-common3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

QT5_ADD_RESOURCES(resources_RCC DialogFromPlugin.qrc)

include_directories(SYSTEM
  ${IGNITION-COMMON_INCLUDE_DIRS}
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-COMMON_LIBRARY_DIRS}
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate examples
add_library(DialogFromPlugin SHARED ${headers_MOC}
  DialogFromPlugin.cc
  ${resources_RCC}
)
target_link_libraries(DialogFromPlugin
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/plugin/hello_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)
find_package(ignition-common3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

QT5_ADD_RESOURCES(resources_RCC hello.qrc)

include_directories(SYSTEM
  ${IGNITION-COMMON_INCLUDE_DIRS}
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-COMMON_LIBRARY_DIRS}
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate examples
add_library(HelloPlugin SHARED ${headers_MOC}
  HelloPlugin.cc
  ${resources_RCC}
)
target_link_libraries(HelloPlugin
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/plugin/ign_components/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

find_package(ignition-gui3 REQUIRED)
find_package(ignition-common3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

QT5_ADD_RESOURCES(resources_RCC IgnComponents.qrc)

include_directories(SYSTEM
  ${IGNITION-COMMON_INCLUDE_DIRS}
  ${IGNITION-GUI_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-COMMON_LIBRARY_DIRS}
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate examples
add_library(IgnComponents SHARED ${headers_MOC}
  IgnComponents.cc
  ${resources_RCC}
)
target_link_libraries(IgnComponents
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/plugin/multiple_qml/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)
find_package(ignition-common3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

QT5_ADD_RESOURCES(resources_RCC MultipleQml.qrc)

include_directories(SYSTEM
  ${IGNITION-COMMON_INCLUDE_DIRS}
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-COMMON_LIBRARY_DIRS}
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate examples
add_library(MultipleQml SHARED ${headers_MOC}
  MultipleQml.cc
  ${resources_RCC}
)
target_link_libraries(MultipleQml
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/standalone/custom_drawer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)

QT5_ADD_RESOURCES(resources_RCC custom_drawer.qrc)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

include_directories(SYSTEM
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate example
add_executable(custom_drawer
  custom_drawer.cc
  ${resources_RCC}
)
target_link_libraries(custom_drawer
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/standalone/dialogs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

include_directories(SYSTEM
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate example
add_executable(dialogs
  dialogs.cc
)
target_link_libraries(dialogs
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== examples/standalone/window/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set (CMAKE_AUTOMOC ON)

# Find Qt5
find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
)

# Find the Ignition gui library
find_package(ignition-gui3 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-GUI_CXX_FLAGS}")

include_directories(SYSTEM
  ${IGNITION-GUI_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Qml_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5QuickControls2_INCLUDE_DIRS}
)

link_directories(
  ${IGNITION-GUI_LIBRARY_DIRS}
)

# Generate example
add_executable(window
  window.cc
)
target_link_libraries(window
  ${IGNITION-GUI_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Qml_LIBRARIES}
  ${Qt5Quick_LIBRARIES}
  ${Qt5QuickControls2_LIBRARIES}
)

=== debian/changelog ===
ignition-gui3 (3.8.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.8.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Tue, 12 Oct 2021 10:40:14 -0700

ignition-gui3 (3.7.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.7.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 14 Jul 2021 20:03:01 -0700

ignition-gui3 (3.6.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.6.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 17 Jun 2021 16:58:14 -0700

ignition-gui3 (3.5.1-3~buster) buster; urgency=medium

  * ignition-gui3 3.5.1-3 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 25 Mar 2021 13:20:23 -0700

ignition-gui3 (3.5.1-2~buster) buster; urgency=medium

  * ignition-gui3 3.5.1-2 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 25 Mar 2021 11:55:07 -0700

ignition-gui3 (3.5.1-1~buster) buster; urgency=medium

  * ignition-gui3 3.5.1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 18 Mar 2021 09:57:28 -0700

ignition-gui3 (3.5.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.5.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Wed, 10 Mar 2021 15:38:03 -0800

ignition-gui3 (3.4.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.4.0-1 release

 -- John Shepherd <john@openrobotics.org>  Fri, 11 Dec 2020 14:50:51 -0800

ignition-gui3 (3.3.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 31 Aug 2020 17:38:03 -0700

ignition-gui3 (3.2.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 22 Jun 2020 20:49:57 -0700

ignition-gui3 (3.1.0-1~buster) buster; urgency=medium

  * ignition-gui3 3.1.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Sat, 28 Mar 2020 09:28:50 -0700

=== debian/control ===
Source: ignition-gui3
Standards-Version: 3.9.8
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9),
               doxygen,
               libtinyxml2-dev,
               libprotoc-dev,
               libprotobuf-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtquickcontrols2-5-dev,
               qml-module-qtquick2,
               qml-module-qtquick-controls,
               qml-module-qtquick-controls2,
               qml-module-qtquick-dialogs,
               qml-module-qtquick-layouts,
               qml-module-qt-labs-folderlistmodel,
               qml-module-qt-labs-settings,
               libignition-cmake2-dev (>= 2.8.0),
               libignition-math6-dev,
               libignition-common3-events-dev,
               libignition-plugin-dev,
               libignition-rendering3-ogre1-dev (>= 3.5.0),
               libignition-tools-dev,
               libignition-transport8-dev,
               libignition-msgs5-dev
Vcs-Browser: https://github.com/ignition-relase/ign-gui3-release
Vcs-Git: https://github.com/ignition-relase/ign-gui3-release
Homepage: http://ignitionrobotics.org/

Package: libignition-gui3
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Gui classes and functions for robot apps - Shared library
  Ignition Gui is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.

Package: libignition-gui3-dev
Architecture: any
Section: libdevel
Depends: libtinyxml2-dev,
         libprotoc-dev,
         libprotobuf-dev,
         qtbase5-dev,
         qtdeclarative5-dev,
         qtquickcontrols2-5-dev,
         qml-module-qtgraphicaleffects,
         qml-module-qtqml-models2,
         qml-module-qtquick2,
         qml-module-qtquick-controls,
         qml-module-qtquick-controls2,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qt-labs-settings,
         libignition-cmake2-dev (>= 2.8.0),
         libignition-math6-dev,
         libignition-common3-events-dev,
         libignition-transport8-dev,
         libignition-plugin-dev,
         libignition-rendering3-ogre1-dev (>= 3.5.0),
         libignition-tools-dev,
         libignition-msgs5-dev,
         libignition-gui3 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Gui classes and functions for robot apps - Development files
  Ignition Gui is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.

## ignition-gui3 3.11.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,12 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-gui3 VERSION 3.8.0)
+project(ignition-gui3 VERSION 3.11.2)
 
 #============================================================================
 # Find ignition-cmake
 #============================================================================
-find_package(ignition-cmake2 2.8.0 REQUIRED)
+find_package(ignition-cmake2 2.14 REQUIRED)
 
 #============================================================================
 # Configure the project
@@ -59,7 +59,7 @@
 
 #--------------------------------------
 # Find ignition-rendering
-ign_find_package(ignition-rendering3 REQUIRED COMPONENTS ogre VERSION 3.5.0)
+ign_find_package(ignition-rendering3 REQUIRED VERSION 3.5.0)
 set(IGN_RENDERING_VER ${ignition-rendering3_VERSION_MAJOR})
 
 #--------------------------------------
@@ -68,8 +68,11 @@
 set(IGN_MSGS_VER ${ignition-msgs5_VERSION_MAJOR})
 
 #--------------------------------------
-# Find if ign command is available
+# Find if command is available. This is used to enable tests.
+# Note that CLI files are installed regardless of whether the dependency is
+# available during build time
 find_program(HAVE_IGN_TOOLS ign)
+set (IGN_TOOLS_VER 1)
 
 #--------------------------------------
 # Find QT
@@ -83,7 +86,7 @@
 )
 
 set(IGNITION_GUI_PLUGIN_INSTALL_DIR
-  ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${IGN_DESIGNATION}-${PROJECT_VERSION_MAJOR}/plugins
+  ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${GZ_DESIGNATION}-${PROJECT_VERSION_MAJOR}/plugins
 )
 
 #============================================================================

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 set (gtest_sources
   Application_TEST
   Conversions_TEST
+  Dialog_TEST
   DragDropModel_TEST
   Helpers_TEST
   GuiEvents_TEST
@@ -46,7 +47,35 @@
                 LIB_DEPS
                   ${IGNITION-MATH_LIBRARIES}
                   TINYXML2::TINYXML2
+                TEST_LIST
+                  gtest_targets
 )
+
+foreach(test ${gtest_targets})
+  target_compile_definitions(${test} PRIVATE
+    "PROJECT_SOURCE_DIR=\"${PROJECT_SOURCE_DIR}\"")
+endforeach()
+
+if(TARGET UNIT_ign_TEST)
+  # Running `ign gazebo` on macOS has problems when run with /usr/bin/ruby
+  # due to System Integrity Protection (SIP). Try to find ruby from
+  # homebrew as a workaround.
+  if (APPLE)
+    find_program(BREW_RUBY ruby HINTS /usr/local/opt/ruby/bin)
+  endif()
+
+  target_compile_definitions(UNIT_ign_TEST PRIVATE
+      "BREW_RUBY=\"${BREW_RUBY} \"")
+
+  target_compile_definitions(UNIT_ign_TEST PRIVATE
+      "IGN_PATH=\"${HAVE_IGN_TOOLS}\"")
+
+  set(_env_vars)
+  list(APPEND _env_vars "IGN_CONFIG_PATH=${CMAKE_BINARY_DIR}/test/conf")
+
+  set_tests_properties(UNIT_ign_TEST PROPERTIES
+    ENVIRONMENT "${_env_vars}")
+endif()
 
 add_subdirectory(cmd)
 add_subdirectory(plugins)

=== src/cmd/CMakeLists.txt ===
# Generate the ruby script.
# Note that the major version of the library is included in the name.
if (APPLE)
  set(IGN_LIBRARY_NAME lib${PROJECT_NAME_LOWER}.dylib)
else()
  set(IGN_LIBRARY_NAME lib${PROJECT_NAME_LOWER}.so)
endif()
configure_file(
  "cmdgui.rb.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmdgui${PROJECT_VERSION_MAJOR}.rb" @ONLY)

# Install the ruby command line library in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmdgui${PROJECT_VERSION_MAJOR}.rb DESTINATION lib/ruby/ignition)

# Tack version onto and install the bash completion script
configure_file(
  "gui.bash_completion.sh"
    "${CMAKE_CURRENT_BINARY_DIR}/gui${PROJECT_VERSION_MAJOR}.bash_completion.sh" @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/gui${PROJECT_VERSION_MAJOR}.bash_completion.sh
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/gz/gz${IGN_TOOLS_VER}.completion.d)

=== src/plugins/CMakeLists.txt ===
--- 
+++ 
@@ -120,6 +120,7 @@
 add_subdirectory(publisher)
 add_subdirectory(scene3d)
 add_subdirectory(screenshot)
+add_subdirectory(shutdown_button)
 add_subdirectory(teleop)
 add_subdirectory(topic_echo)
 add_subdirectory(topic_viewer)

=== examples/plugin/custom_context_menu/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-custom-context-menu)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/plugin/dialog_from_plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-dialog-from-plugin)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/plugin/hello_plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-hello-plugin)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/plugin/ign_components/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-ign-components)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/plugin/multiple_qml/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-multiple-qml)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/standalone/custom_drawer/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-custom-drawer)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/standalone/dialogs/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
+
+project(ignition-gui-dialogs)
 
 if(POLICY CMP0100)
   cmake_policy(SET CMP0100 NEW)

=== examples/standalone/start_dialog/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

project(gz-gui-start-dialog)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

set(CMAKE_AUTOMOC ON)

find_package(ignition-gui3 REQUIRED)
set(GZ_GUI_VER ${ignition-gui3_VERSION_MAJOR})

set(EXEC_NAME "start_dialog")

QT5_ADD_RESOURCES(resources_RCC ${EXEC_NAME}.qrc)

add_executable(${EXEC_NAME}
  ${EXEC_NAME}.cc
  ${resources_RCC}
)
target_link_libraries(${EXEC_NAME}
  ignition-gui${GZ_GUI_VER}::ignition-gui${GZ_GUI_VER}
)

=== debian/changelog ===
ignition-gui3 (3.11.2-1~focal) focal; urgency=medium

  * ignition-gui3 3.11.2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 17 Aug 2022 13:27:41 -0700

ignition-gui3 (3.11.1-1~focal) focal; urgency=medium

  * ignition-gui3 3.11.1-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 16 Aug 2022 11:34:34 -0700

ignition-gui3 (3.11.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.11.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 02 Aug 2022 10:17:23 -0700

ignition-gui3 (3.10.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.10.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Wed, 13 Jul 2022 15:14:43 -0700

ignition-gui3 (3.9.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.9.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 21 Jan 2022 09:12:24 -0800

ignition-gui3 (3.8.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.8.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Tue, 12 Oct 2021 10:40:14 -0700

ignition-gui3 (3.7.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.7.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 14 Jul 2021 20:03:01 -0700

ignition-gui3 (3.6.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.6.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 17 Jun 2021 16:58:14 -0700

ignition-gui3 (3.5.1-3~focal) focal; urgency=medium

  * ignition-gui3 3.5.1-3 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 25 Mar 2021 13:20:22 -0700

ignition-gui3 (3.5.1-2~focal) focal; urgency=medium

  * ignition-gui3 3.5.1-2 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 25 Mar 2021 11:55:06 -0700

ignition-gui3 (3.5.1-1~focal) focal; urgency=medium

  * ignition-gui3 3.5.1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 18 Mar 2021 09:57:28 -0700

ignition-gui3 (3.5.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.5.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Wed, 10 Mar 2021 15:38:03 -0800

ignition-gui3 (3.4.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.4.0-1 release

 -- John Shepherd <john@openrobotics.org>  Fri, 11 Dec 2020 14:50:51 -0800

ignition-gui3 (3.3.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 31 Aug 2020 17:38:03 -0700

ignition-gui3 (3.2.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 22 Jun 2020 20:49:57 -0700

ignition-gui3 (3.1.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.1.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Sat, 28 Mar 2020 09:28:50 -0700

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
                qml-module-qtquick-layouts,
                qml-module-qt-labs-folderlistmodel,
                qml-module-qt-labs-settings,
-               libignition-cmake2-dev (>= 2.8.0),
+               libignition-cmake2-dev (>= 2.14.0),
                libignition-math6-dev,
                libignition-common3-events-dev,
                libignition-plugin-dev,
@@ -28,9 +28,9 @@
                libignition-tools-dev,
                libignition-transport8-dev,
                libignition-msgs5-dev
-Vcs-Browser: https://github.com/ignition-relase/ign-gui3-release
-Vcs-Git: https://github.com/ignition-relase/ign-gui3-release
-Homepage: http://ignitionrobotics.org/
+Vcs-Browser: https://github.com/gazebosim/gz-gui
+Vcs-Git: https://github.com/gazebosim/gz-gui
+Homepage: http://gazebosim.org/
 
 Package: libignition-gui3
 Architecture: any
@@ -38,8 +38,8 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
-Description: Ignition Gui classes and functions for robot apps - Shared library
-  Ignition Gui is a component in the ignition framework, a set of libraries
+Description: Gazebo Gui classes and functions for robot apps - Shared library
+  Gazebo Gui is a component in the Gazebo framework, a set of libraries
   designed to rapidly develop robot applications.
 
 Package: libignition-gui3-dev
@@ -60,7 +60,7 @@
          qml-module-qtquick-layouts,
          qml-module-qt-labs-folderlistmodel,
          qml-module-qt-labs-settings,
-         libignition-cmake2-dev (>= 2.8.0),
+         libignition-cmake2-dev (>= 2.14.0),
          libignition-math6-dev,
          libignition-common3-events-dev,
          libignition-transport8-dev,
@@ -71,6 +71,22 @@
          libignition-gui3 (= ${binary:Version}),
          ${misc:Depends}
 Multi-Arch: same
-Description: Ignition Gui classes and functions for robot apps - Development files
-  Ignition Gui is a component in the ignition framework, a set of libraries
+Description: Gazebo Gui classes and functions for robot apps - Development files
+  Gazebo Gui is a component in the Gazebo framework, a set of libraries
   designed to rapidly develop robot applications.
+
+Package: libgz-gui3
+Depends: libignition-gui3, ${misc:Depends}
+Architecture: all
+Priority: optional
+Section: oldlibs
+Description: transitional package
+ It's recommended to use the gz packages going forward.
+
+Package: libgz-gui3-dev
+Depends: libignition-gui3-dev, ${misc:Depends}
+Architecture: all
+Priority: optional
+Section: oldlibs
+Description: transitional package
+ It's recommended to use the gz packages going forward.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

.PHONY: override_dh_auto_configure \
        override_dh_auto_test

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

# test cannot run in parallel
override_dh_auto_test:
	true
# dh_auto_test --max-parallel=1

## ignition-gui3 3.12.0

=== debian/changelog ===
ignition-gui3 (3.12.0-1~focal) focal; urgency=medium

  * ignition-gui3 3.12.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Wed, 30 Nov 2022 14:41:21 -0800

ignition-gui3 (3.12.0~pre1-1~focal) focal; urgency=medium

  * ignition-gui3 3.12.0~pre1-1 release

 -- Nate Koenig <nate@openrobotics.org>  Wed, 30 Nov 2022 13:19:43 -0800
